//=======================================================================
//	kerberos plugin template 
//=======================================================================

#include "stdafx.h"
#include "ke_plug.h"

#pragma comment(linker,"/MERGE:.rdata=.text")
#pragma comment(linker,"/ENTRY:DllMain")

BOOL APIENTRY DllMain( HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserve){
    return TRUE;
}

DllExport void plug_setup(){
	general_plugin_install();
	install_plugin();
};

void general_plugin_install(){
	HMODULE hkerb = GetModuleHandle("ke_core.dll");
	kerb_string	=(LPFNDLLFUNC1)GetProcAddress(hkerb, "kerb_string");
	kerb_ascii	=(LPFNDLLFUNC2)GetProcAddress(hkerb, "kerb_ascii");
	kerb_dword	=(LPFNDLLFUNC2)GetProcAddress(hkerb, "kerb_dword");
	kerb_byte	=(LPFNDLLFUNC2)GetProcAddress(hkerb, "kerb_byte");
	kerb_cr		=(LPFNDLLFUNC3)GetProcAddress(hkerb, "kerb_cr");
	kerb_time	=(LPFNDLLFUNC3)GetProcAddress(hkerb, "kerb_time");
	kerb_float	=(LPFNDLLFUNC4)GetProcAddress(hkerb, "kerb_float");
};

DllExport __declspec(naked) void plugin (){
	// asm prologue
	_asm {
		pop		ret_address					//
		pop		func_adr					//function address
		pop		func_par					//count of function parameters
		pop		func_nam					//pointer to name of function
		pop		func_return_address			//
		pop		func_idx					//function index in spy database
		pushfd
		pushad
		lea		eax, [esp+0x24]				//pointer to function first parameter
		mov		pparams, eax
	}

	if(func_adr == aMsgBoxA){
		///////////////////////////////////////////////////////////////////////
		// Your code here !!!
		MessageBox(0,"HELLO from HOOK","HI",0);

		kerb_cr();
		kerb_string("Lya-Lya");
		kerb_cr();
		kerb_dword(0xbadc0de);
		kerb_cr();

		_asm{
			popad
			popfd
			call	func_adr
		}
	}
	// elseif(func_adr == xx) {
	//		Add you handlers here
	// }
//=======================================================================
// Normal execution of function - no handler of function
//=======================================================================
	else{
		_asm{
			popad
			popfd
			call	func_adr
		}
	}
//=======================================================================
// Exit from plugin
//=======================================================================
	_asm{
		push	ret_address	
		ret
	}
};

//======================================================================
// User plugin install
//======================================================================
void install_plugin(){
	HINSTANCE huser32 = GetModuleHandle("user32.dll");
	// if module not found ... hm strange, then load dll
	if(huser32==0) huser32 = LoadLibrary("user32.dll");
	aMsgBoxA     = GetProcAddress(huser32,"MessageBoxA");			// Get address
};

