//=======================================================================
//	kerberos plugin
//  Stack Dumper
//=======================================================================

#include "stdafx.h"
#include "ke_plug.h"

#pragma comment(linker,"/MERGE:.rdata=.text")
#pragma comment(linker,"/ENTRY:DllMain")

BOOL APIENTRY DllMain( HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserve){
    return TRUE;
}

DllExport void plug_setup(){
	general_plugin_install();
	install_plugin();
};

void general_plugin_install(){
	HMODULE hkerb = GetModuleHandle("ke_core.dll");
	kerb_string	=(LPFNDLLFUNC1)GetProcAddress(hkerb, "kerb_string");
	kerb_ascii	=(LPFNDLLFUNC2)GetProcAddress(hkerb, "kerb_ascii");
	kerb_dword	=(LPFNDLLFUNC2)GetProcAddress(hkerb, "kerb_dword");
	kerb_byte	=(LPFNDLLFUNC2)GetProcAddress(hkerb, "kerb_byte");
	kerb_cr		=(LPFNDLLFUNC3)GetProcAddress(hkerb, "kerb_cr");
	kerb_time	=(LPFNDLLFUNC3)GetProcAddress(hkerb, "kerb_time");
	kerb_float	=(LPFNDLLFUNC4)GetProcAddress(hkerb, "kerb_float");
};

DllExport __declspec(naked) void plugin (){
	// asm prologue
	_asm {
		pop		ret_address					//
		pop		func_adr					//function address
		pop		func_par					//count of function parameters
		pop		func_nam					//pointer to name of function
		pop		func_return_address			//
		pop		func_idx					//function index in spy database
		pushfd
		pushad
		lea		eax, [esp+0x24]				//pointer to function first parameter
		mov		pparams, eax				//
	}

		//Stack dumper
		kerb_cr();
		kerb_string("Stack: ");
		pparams+=4*func_par;				//Move to
		for(int i=0; i<16; i++){
			kerb_dword(*(DWORD*)pparams);
			kerb_string("  ");
			pparams+=4;
		}
		kerb_cr();

		//Function Call
		_asm{
			popad
			popfd
			call	func_adr
		}
	//Return To Spy
	_asm{
		push	ret_address	
		ret
	}
};

void install_plugin(){

};

